! WHIZARD 1.10 Apr 20 2001
! 
! (C) 1999, 2000 by Wolfgang Kilian <kilian@particle.uni-karlsruhe.de>
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This file has been stripped of most comments.  For documentation, refer
! to the source 'whizard.nw'

module jetset_interface

  implicit none
  private

  integer, parameter, public :: PYGIVE_LEN = 100

  public :: jetset_init
  public :: jetset_fragment
  public :: jetset_write
  public :: jetset_suppress_banner

contains

  subroutine jetset_init (chin)
    character(len=PYGIVE_LEN), intent(in) :: chin
  end subroutine jetset_init
  subroutine jetset_fragment ()
    stop "PYTHIA not linked.  Can't call JETSET, sorry."
  end subroutine jetset_fragment
  subroutine jetset_write (mlist)
    integer, intent(in) :: mlist
    stop "PYTHIA not linked: No event listing in JETSET format, sorry"
  end subroutine jetset_write
  subroutine jetset_suppress_banner
  end subroutine jetset_suppress_banner

end module jetset_interface
